function set_color, s
;
; return idl color value based on X color string
;
c = 0
t = strlowcase(strtrim(s,2))
i = 256L
case t of
    'floralwhite':   c = 255 + (250 + 240 *i) * i
    'oldlace':       c = 253 + (245 + 230 *i) * i
    'linen':         c = 250 + (240 + 230 *i) * i
    'antiquewhite':  c = 250 + (235 + 215 *i) * i
    'papayawhip':    c = 255 + (239 + 213 *i) * i
    'blanchedalmond': c = 255 + (235 + 205 *i) * i
    'bisque':        c = 255 + (228 + 196 *i) * i
    'peachpuff':     c = 255 + (218 + 185 *i) * i
    'navajowhite':   c = 255 + (222 + 173 *i) * i
    'moccasin':      c = 255 + (228 + 181 *i) * i
    'cornsilk':      c = 255 + (248 + 220 *i) * i
    'ivory':         c = 255 + (255 + 240 *i) * i
    'lemonchiffon':  c = 255 + (250 + 205 *i) * i
    'seashell':      c = 255 + (245 + 238 *i) * i
    'honeydew':      c = 240 + (255 + 240 *i) * i
    'mint cream':    c = 245 + (255 + 250 *i) * i
    'mintcream':     c = 245 + (255 + 250 *i) * i
    'azure':         c = 240 + (255 + 255 *i) * i
    'aliceblue':     c = 240 + (248 + 255 *i) * i
    'lavender':      c = 230 + (230 + 250 *i) * i
    'lavenderblush': c = 255 + (240 + 245 *i) * i
    'mistyrose':     c = 255 + (228 + 225 *i) * i
    'white':         c = 255 + (255 + 255 *i) * i
    'black':         c =   0 + (  0 +   0 *i) * i
    'darkslategray': c =  47 + ( 79 +  79 *i) * i
    'darkslategrey': c =  47 + ( 79 +  79 *i) * i
    'dimgray':       c = 105 + (105 + 105 *i) * i
    'dimgrey':       c = 105 + (105 + 105 *i) * i
    'slategray':     c = 112 + (128 + 144 *i) * i
    'slategrey':     c = 112 + (128 + 144 *i) * i
    'lightslategray':c = 119 + (136 + 153 *i) * i
    'lightslategrey':c = 119 + (136 + 153 *i) * i
    'gray':          c = 190 + (190 + 190 *i) * i
    'grey':          c = 190 + (190 + 190 *i) * i
    'lightgrey':     c = 211 + (211 + 211 *i) * i
    'lightgray':     c = 211 + (211 + 211 *i) * i
    'midnightblue':  c =  25 + ( 25 + 112 *i) * i
    'navy':          c =   0 + (  0 + 128 *i) * i
    'navyblue':      c =   0 + (  0 + 128 *i) * i
    'cornflowerblue':c = 100 + (149 + 237 *i) * i
    'darkslateblue': c =  72 + ( 61 + 139 *i) * i
    'slateblue':     c = 106 + ( 90 + 205 *i) * i
    'mediumslateblue': c = 123 + (104 + 238 *i) * i
    'lightslateblue':  c = 132 + (112 + 255 *i) * i
    'mediumblue':    c =   0 + (  0 + 205 *i) * i
    'royalblue':     c =  65 + (105 + 225 *i) * i
    'blue':          c =   0 + (  0 + 255 *i) * i
    'dodgerblue':    c =  30 + (144 + 255 *i) * i
    'deepskyblue':   c =   0 + (191 + 255 *i) * i
    'skyblue':       c = 135 + (206 + 235 *i) * i
    'lightskyblue':  c = 135 + (206 + 250 *i) * i
    'steelblue':     c =  70 + (130 + 180 *i) * i
    'lightsteelblue': c = 176 + (196 + 222 *i) * i
    'lightblue':     c = 173 + (216 + 230 *i) * i
    'powderblue':    c = 176 + (224 + 230 *i) * i
    'paleturquoise': c = 175 + (238 + 238 *i) * i
    'darkturquoise': c =   0 + (206 + 209 *i) * i
    'mediumturquoise': c =  72 + (209 + 204 *i) * i
    'turquoise':     c =  64 + (224 + 208 *i) * i
    'cyan':          c =   0 + (255 + 255 *i) * i
    'lightcyan':     c = 224 + (255 + 255 *i) * i
    'cadetblue':     c =  95 + (158 + 160 *i) * i
    'mediumaquamarine': c = 102 + (205 + 170 *i) * i
    'aquamarine':    c = 127 + (255 + 212 *i) * i
    'darkgreen':     c =   0 + (100 +   0 *i) * i
    'darkolivegreen': c =  85 + (107 +  47 *i) * i
    'darkseagreen':  c = 143 + (188 + 143 *i) * i
    'seagreen':      c =  46 + (139 +  87 *i) * i
    'mediumseagreen': c =  60 + (179 + 113 *i) * i
    'lightseagreen': c =  32 + (178 + 170 *i) * i
    'palegreen':     c = 152 + (251 + 152 *i) * i
    'springgreen':   c =   0 + (255 + 127 *i) * i
    'lawngreen':     c = 124 + (252 +   0 *i) * i
    'green':         c =   0 + (255 +   0 *i) * i
    'chartreuse':    c = 127 + (255 +   0 *i) * i
    'mediumspringgreen': c =   0 + (250 + 154 *i) * i
    'greenyellow':   c = 173 + (255 +  47 *i) * i
    'limegreen':     c =  50 + (205 +  50 *i) * i
    'yellowgreen':   c = 154 + (205 +  50 *i) * i
    'forestgreen':   c =  34 + (139 +  34 *i) * i
    'olivedrab':     c = 107 + (142 +  35 *i) * i
    'darkkhaki':     c = 189 + (183 + 107 *i) * i
    'khaki':         c = 240 + (230 + 140 *i) * i
    'palegoldenrod': c = 238 + (232 + 170 *i) * i
    'lightgoldenrodyellow': c = 250 + (250 + 210 *i) * i
    'lightyellow':   c = 255 + (255 + 224 *i) * i
    'yellow':        c = 255 + (255 +   0 *i) * i
    'gold':          c = 255 + (215 +   0 *i) * i
    'lightgoldenrod': c = 238 + (221 + 130 *i) * i
    'goldenrod':     c = 218 + (165 +  32 *i) * i
    'darkgoldenrod': c = 184 + (134 +  11 *i) * i
    'rosybrown':     c = 188 + (143 + 143 *i) * i
    'indianred':     c = 205 + ( 92 +  92 *i) * i
    'saddlebrown':   c = 139 + ( 69 +  19 *i) * i
    'sienna':        c = 160 + ( 82 +  45 *i) * i
    'peru':          c = 205 + (133 +  63 *i) * i
    'burlywood':     c = 222 + (184 + 135 *i) * i
    'beige':         c = 245 + (245 + 220 *i) * i
    'wheat':         c = 245 + (222 + 179 *i) * i
    'sandybrown':    c = 244 + (164 +  96 *i) * i
    'tan':           c = 210 + (180 + 140 *i) * i
    'chocolate':     c = 210 + (105 +  30 *i) * i
    'firebrick':     c = 178 + ( 34 +  34 *i) * i
    'brown': c = 165 + ( 42 +  42 *i) * i
    'darksalmon': c = 233 + (150 + 122 *i) * i
    'salmon': c = 250 + (128 + 114 *i) * i
    'lightsalmon': c = 255 + (160 + 122 *i) * i
    'orange': c = 255 + (165 +   0 *i) * i
    'darkorange': c = 255 + (140 +   0 *i) * i
    'coral': c = 255 + (127 +  80 *i) * i
    'lightcoral': c = 240 + (128 + 128 *i) * i
    'tomato': c = 255 + ( 99 +  71 *i) * i
    'orangered': c = 255 + ( 69 +   0 *i) * i
    'red': c = 255 + (  0 +   0 *i) * i
    'hotpink': c = 255 + (105 + 180 *i) * i
    'deeppink': c = 255 + ( 20 + 147 *i) * i
    'pink': c = 255 + (192 + 203 *i) * i
    'lightpink': c = 255 + (182 + 193 *i) * i
    'palevioletred': c = 219 + (112 + 147 *i) * i
    'maroon': c = 176 + ( 48 +  96 *i) * i
    'mediumvioletred': c = 199 + ( 21 + 133 *i) * i
    'violetred': c = 208 + ( 32 + 144 *i) * i
    'magenta': c = 255 + (  0 + 255 *i) * i
    'violet': c = 238 + (130 + 238 *i) * i
    'plum': c = 221 + (160 + 221 *i) * i
    'orchid': c = 218 + (112 + 214 *i) * i
    'mediumorchid': c = 186 + ( 85 + 211 *i) * i
    'darkorchid': c = 153 + ( 50 + 204 *i) * i
    'darkviolet': c = 148 + (  0 + 211 *i) * i
    'blueviolet': c = 138 + ( 43 + 226 *i) * i
    'purple': c = 160 + ( 32 + 240 *i) * i
    'mediumpurple': c = 147 + (112 + 219 *i) * i
    'thistle': c = 216 + (191 + 216 *i) * i
    'snow1': c = 255 + (250 + 250 *i) * i
    'snow2': c = 238 + (233 + 233 *i) * i
    'snow3': c = 205 + (201 + 201 *i) * i
    'snow4': c = 139 + (137 + 137 *i) * i
    'seashell1': c = 255 + (245 + 238 *i) * i
    'seashell2': c = 238 + (229 + 222 *i) * i
    'seashell3': c = 205 + (197 + 191 *i) * i
    'seashell4': c = 139 + (134 + 130 *i) * i
    'antiquewhite1': c = 255 + (239 + 219 *i) * i
    'antiquewhite2': c = 238 + (223 + 204 *i) * i
    'antiquewhite3': c = 205 + (192 + 176 *i) * i
    'antiquewhite4': c = 139 + (131 + 120 *i) * i
    'bisque1': c = 255 + (228 + 196 *i) * i
    'bisque2': c = 238 + (213 + 183 *i) * i
    'bisque3': c = 205 + (183 + 158 *i) * i
    'bisque4': c = 139 + (125 + 107 *i) * i
    'peachpuff1': c = 255 + (218 + 185 *i) * i
    'peachpuff2': c = 238 + (203 + 173 *i) * i
    'peachpuff3': c = 205 + (175 + 149 *i) * i
    'peachpuff4': c = 139 + (119 + 101 *i) * i
    'navajowhite1': c = 255 + (222 + 173 *i) * i
    'navajowhite2': c = 238 + (207 + 161 *i) * i
    'navajowhite3': c = 205 + (179 + 139 *i) * i
    'navajowhite4': c = 139 + (121 +	 94 *i) * i
    'lemonchiffon1': c = 255 + (250 + 205 *i) * i
    'lemonchiffon2': c = 238 + (233 + 191 *i) * i
    'lemonchiffon3': c = 205 + (201 + 165 *i) * i
    'lemonchiffon4': c = 139 + (137 + 112 *i) * i
    'cornsilk1': c = 255 + (248 + 220 *i) * i
    'cornsilk2': c = 238 + (232 + 205 *i) * i
    'cornsilk3': c = 205 + (200 + 177 *i) * i
    'cornsilk4': c = 139 + (136 + 120 *i) * i
    'ivory1': c = 255 + (255 + 240 *i) * i
    'ivory2': c = 238 + (238 + 224 *i) * i
    'ivory3': c = 205 + (205 + 193 *i) * i
    'ivory4': c = 139 + (139 + 131 *i) * i
    'honeydew1': c = 240 + (255 + 240 *i) * i
    'honeydew2': c = 224 + (238 + 224 *i) * i
    'honeydew3': c = 193 + (205 + 193 *i) * i
    'honeydew4': c = 131 + (139 + 131 *i) * i
    'lavenderblush1': c = 255 + (240 + 245 *i) * i
    'lavenderblush2': c = 238 + (224 + 229 *i) * i
    'lavenderblush3': c = 205 + (193 + 197 *i) * i
    'lavenderblush4': c = 139 + (131 + 134 *i) * i
    'mistyrose1': c = 255 + (228 + 225 *i) * i
    'mistyrose2': c = 238 + (213 + 210 *i) * i
    'mistyrose3': c = 205 + (183 + 181 *i) * i
    'mistyrose4': c = 139 + (125 + 123 *i) * i
    'azure1': c = 240 + (255 + 255 *i) * i
    'azure2': c = 224 + (238 + 238 *i) * i
    'azure3': c = 193 + (205 + 205 *i) * i
    'azure4': c = 131 + (139 + 139 *i) * i
    'slateblue1': c = 131 + (111 + 255 *i) * i
    'slateblue2': c = 122 + (103 + 238 *i) * i
    'slateblue3': c = 105 + ( 89 + 205 *i) * i
    'slateblue4': c =  71 + ( 60 + 139 *i) * i
    'royalblue1': c =  72 + (118 + 255 *i) * i
    'royalblue2': c =  67 + (110 + 238 *i) * i
    'royalblue3': c =  58 + ( 95 + 205 *i) * i
    'royalblue4': c =  39 + ( 64 + 139 *i) * i
    'blue1': c =   0 + (  0 + 255 *i) * i
    'blue2': c =   0 + (  0 + 238 *i) * i
    'blue3': c =   0 + (  0 + 205 *i) * i
    'blue4': c =   0 + (  0 + 139 *i) * i
    'dodgerblue1': c =  30 + (144 + 255 *i) * i
    'dodgerblue2': c =  28 + (134 + 238 *i) * i
    'dodgerblue3': c =  24 + (116 + 205 *i) * i
    'dodgerblue4': c =  16 + ( 78 + 139 *i) * i
    'steelblue1': c =  99 + (184 + 255 *i) * i
    'steelblue2': c =  92 + (172 + 238 *i) * i
    'steelblue3': c =  79 + (148 + 205 *i) * i
    'steelblue4': c =  54 + (100 + 139 *i) * i
    'deepskyblue1': c =   0 + (191 + 255 *i) * i
    'deepskyblue2': c =   0 + (178 + 238 *i) * i
    'deepskyblue3': c =   0 + (154 + 205 *i) * i
    'deepskyblue4': c =   0 + (104 + 139 *i) * i
    'skyblue1': c = 135 + (206 + 255 *i) * i
    'skyblue2': c = 126 + (192 + 238 *i) * i
    'skyblue3': c = 108 + (166 + 205 *i) * i
    'skyblue4': c =  74 + (112 + 139 *i) * i
    'lightskyblue1': c = 176 + (226 + 255 *i) * i
    'lightskyblue2': c = 164 + (211 + 238 *i) * i
    'lightskyblue3': c = 141 + (182 + 205 *i) * i
    'lightskyblue4': c =  96 + (123 + 139 *i) * i
    'slategray1': c = 198 + (226 + 255 *i) * i
    'slategray2': c = 185 + (211 + 238 *i) * i
    'slategray3': c = 159 + (182 + 205 *i) * i
    'slategray4': c = 108 + (123 + 139 *i) * i
    'lightsteelblue1': c = 202 + (225 + 255 *i) * i
    'lightsteelblue2': c = 188 + (210 + 238 *i) * i
    'lightsteelblue3': c = 162 + (181 + 205 *i) * i
    'lightsteelblue4': c = 110 + (123 + 139 *i) * i
    'lightblue1': c = 191 + (239 + 255 *i) * i
    'lightblue2': c = 178 + (223 + 238 *i) * i
    'lightblue3': c = 154 + (192 + 205 *i) * i
    'lightblue4': c = 104 + (131 + 139 *i) * i
    'lightcyan1': c = 224 + (255 + 255 *i) * i
    'lightcyan2': c = 209 + (238 + 238 *i) * i
    'lightcyan3': c = 180 + (205 + 205 *i) * i
    'lightcyan4': c = 122 + (139 + 139 *i) * i
    'paleturquoise1': c = 187 + (255 + 255 *i) * i
    'paleturquoise2': c = 174 + (238 + 238 *i) * i
    'paleturquoise3': c = 150 + (205 + 205 *i) * i
    'paleturquoise4': c = 102 + (139 + 139 *i) * i
    'cadetblue1': c = 152 + (245 + 255 *i) * i
    'cadetblue2': c = 142 + (229 + 238 *i) * i
    'cadetblue3': c = 122 + (197 + 205 *i) * i
    'cadetblue4': c =  83 + (134 + 139 *i) * i
    'turquoise1': c =   0 + (245 + 255 *i) * i
    'turquoise2': c =   0 + (229 + 238 *i) * i
    'turquoise3': c =   0 + (197 + 205 *i) * i
    'turquoise4': c =   0 + (134 + 139 *i) * i
    'cyan1': c =   0 + (255 + 255 *i) * i
    'cyan2': c =   0 + (238 + 238 *i) * i
    'cyan3': c =   0 + (205 + 205 *i) * i
    'cyan4': c =   0 + (139 + 139 *i) * i
    'darkslategray1': c = 151 + (255 + 255 *i) * i
    'darkslategray2': c = 141 + (238 + 238 *i) * i
    'darkslategray3': c = 121 + (205 + 205 *i) * i
    'darkslategray4': c =  82 + (139 + 139 *i) * i
    'aquamarine1': c = 127 + (255 + 212 *i) * i
    'aquamarine2': c = 118 + (238 + 198 *i) * i
    'aquamarine3': c = 102 + (205 + 170 *i) * i
    'aquamarine4': c =  69 + (139 + 116 *i) * i
    'darkseagreen1': c = 193 + (255 + 193 *i) * i
    'darkseagreen2': c = 180 + (238 + 180 *i) * i
    'darkseagreen3': c = 155 + (205 + 155 *i) * i
    'darkseagreen4': c = 105 + (139 + 105 *i) * i
    'seagreen1': c =  84 + (255 + 159 *i) * i
    'seagreen2': c =  78 + (238 + 148 *i) * i
    'seagreen3': c =  67 + (205 + 128 *i) * i
    'seagreen4': c =  46 + (139 +	 87 *i) * i
    'palegreen1': c = 154 + (255 + 154 *i) * i
    'palegreen2': c = 144 + (238 + 144 *i) * i
    'palegreen3': c = 124 + (205 + 124 *i) * i
    'palegreen4': c =  84 + (139 +	 84 *i) * i
    'springgreen1': c =   0 + (255 + 127 *i) * i
    'springgreen2': c =   0 + (238 + 118 *i) * i
    'springgreen3': c =   0 + (205 + 102 *i) * i
    'springgreen4': c =   0 + (139 +	 69 *i) * i
    'green1': c =   0 + (255 +	  0 *i) * i
    'green2': c =   0 + (238 +	  0 *i) * i
    'green3': c =   0 + (205 +	  0 *i) * i
    'green4': c =   0 + (139 +	  0 *i) * i
    'chartreuse1': c = 127 + (255 +	  0 *i) * i
    'chartreuse2': c = 118 + (238 +	  0 *i) * i
    'chartreuse3': c = 102 + (205 +	  0 *i) * i
    'chartreuse4': c =  69 + (139 +	  0 *i) * i
    'olivedrab1': c = 192 + (255 +	 62 *i) * i
    'olivedrab2': c = 179 + (238 +	 58 *i) * i
    'olivedrab3': c = 154 + (205 +	 50 *i) * i
    'olivedrab4': c = 105 + (139 +	 34 *i) * i
    'darkolivegreen1': c = 202 + (255 + 112 *i) * i
    'darkolivegreen2': c = 188 + (238 + 104 *i) * i
    'darkolivegreen3': c = 162 + (205 +	 90 *i) * i
    'darkolivegreen4': c = 110 + (139 +	 61 *i) * i
    'khaki1': c = 255 + (246 + 143 *i) * i
    'khaki2': c = 238 + (230 + 133 *i) * i
    'khaki3': c = 205 + (198 + 115 *i) * i
    'khaki4': c = 139 + (134 +	 78 *i) * i
    'lightgoldenrod1': c = 255 + (236 + 139 *i) * i
    'lightgoldenrod2': c = 238 + (220 + 130 *i) * i
    'lightgoldenrod3': c = 205 + (190 + 112 *i) * i
    'lightgoldenrod4': c = 139 + (129 +	 76 *i) * i
    'lightyellow1': c = 255 + (255 + 224 *i) * i
    'lightyellow2': c = 238 + (238 + 209 *i) * i
    'lightyellow3': c = 205 + (205 + 180 *i) * i
    'lightyellow4': c = 139 + (139 + 122 *i) * i
    'yellow1': c = 255 + (255 +	  0 *i) * i
    'yellow2': c = 238 + (238 +	  0 *i) * i
    'yellow3': c = 205 + (205 +	  0 *i) * i
    'yellow4': c = 139 + (139 +	  0 *i) * i
    'gold1': c = 255 + (215 +	  0 *i) * i
    'gold2': c = 238 + (201 +	  0 *i) * i
    'gold3': c = 205 + (173 +	  0 *i) * i
    'gold4': c = 139 + (117 +	  0 *i) * i
    'goldenrod1': c = 255 + (193 +	 37 *i) * i
    'goldenrod2': c = 238 + (180 +	 34 *i) * i
    'goldenrod3': c = 205 + (155 +	 29 *i) * i
    'goldenrod4': c = 139 + (105 +	 20 *i) * i
    'darkgoldenrod1': c = 255 + (185 +	 15 *i) * i
    'darkgoldenrod2': c = 238 + (173 +	 14 *i) * i
    'darkgoldenrod3': c = 205 + (149 +	 12 *i) * i
    'darkgoldenrod4': c = 139 + (101 +	  8 *i) * i
    'rosybrown1': c = 255 + (193 + 193 *i) * i
    'rosybrown2': c = 238 + (180 + 180 *i) * i
    'rosybrown3': c = 205 + (155 + 155 *i) * i
    'rosybrown4': c = 139 + (105 + 105 *i) * i
    'indianred1': c = 255 + (106 + 106 *i) * i
    'indianred2': c = 238 + ( 99 +	 99 *i) * i
    'indianred3': c = 205 + ( 85 +	 85 *i) * i
    'indianred4': c = 139 + ( 58 +	 58 *i) * i
    'sienna1': c = 255 + (130 +	 71 *i) * i
    'sienna2': c = 238 + (121 +	 66 *i) * i
    'sienna3': c = 205 + (104 +	 57 *i) * i
    'sienna4': c = 139 + ( 71 +	 38 *i) * i
    'burlywood1': c = 255 + (211 + 155 *i) * i
    'burlywood2': c = 238 + (197 + 145 *i) * i
    'burlywood3': c = 205 + (170 + 125 *i) * i
    'burlywood4': c = 139 + (115 +	 85 *i) * i
    'wheat1': c = 255 + (231 + 186 *i) * i
    'wheat2': c = 238 + (216 + 174 *i) * i
    'wheat3': c = 205 + (186 + 150 *i) * i
    'wheat4': c = 139 + (126 + 102 *i) * i
    'tan1': c = 255 + (165 +	 79 *i) * i
    'tan2': c = 238 + (154 +	 73 *i) * i
    'tan3': c = 205 + (133 +	 63 *i) * i
    'tan4': c = 139 + ( 90 +	 43 *i) * i
    'chocolate1': c = 255 + (127 +	 36 *i) * i
    'chocolate2': c = 238 + (118 +	 33 *i) * i
    'chocolate3': c = 205 + (102 +	 29 *i) * i
    'chocolate4': c = 139 + ( 69 +	 19 *i) * i
    'firebrick1': c = 255 + ( 48 +	 48 *i) * i
    'firebrick2': c = 238 + ( 44 +	 44 *i) * i
    'firebrick3': c = 205 + ( 38 +	 38 *i) * i
    'firebrick4': c = 139 + ( 26 +	 26 *i) * i
    'brown1': c = 255 + ( 64 +	 64 *i) * i
    'brown2': c = 238 + ( 59 +	 59 *i) * i
    'brown3': c = 205 + ( 51 +	 51 *i) * i
    'brown4': c = 139 + ( 35 +	 35 *i) * i
    'salmon1': c = 255 + (140 + 105 *i) * i
    'salmon2': c = 238 + (130 +	 98 *i) * i
    'salmon3': c = 205 + (112 +	 84 *i) * i
    'salmon4': c = 139 + ( 76 +	 57 *i) * i
    'lightsalmon1': c = 255 + (160 + 122 *i) * i
    'lightsalmon2': c = 238 + (149 + 114 *i) * i
    'lightsalmon3': c = 205 + (129 +	 98 *i) * i
    'lightsalmon4': c = 139 + ( 87 +	 66 *i) * i
    'orange1': c = 255 + (165 +	  0 *i) * i
    'orange2': c = 238 + (154 +	  0 *i) * i
    'orange3': c = 205 + (133 +	  0 *i) * i
    'orange4': c = 139 + ( 90 +	  0 *i) * i
    'darkorange1': c = 255 + (127 +	  0 *i) * i
    'darkorange2': c = 238 + (118 +	  0 *i) * i
    'darkorange3': c = 205 + (102 +	  0 *i) * i
    'darkorange4': c = 139 + ( 69 +	  0 *i) * i
    'coral1': c = 255 + (114 +	 86 *i) * i
    'coral2': c = 238 + (106 +	 80 *i) * i
    'coral3': c = 205 + ( 91 +	 69 *i) * i
    'coral4': c = 139 + ( 62 +	 47 *i) * i
    'tomato1': c = 255 + ( 99 +	 71 *i) * i
    'tomato2': c = 238 + ( 92 +	 66 *i) * i
    'tomato3': c = 205 + ( 79 +	 57 *i) * i
    'tomato4': c = 139 + ( 54 +	 38 *i) * i
    'orangered1': c = 255 + ( 69 +	  0 *i) * i
    'orangered2': c = 238 + ( 64 +	  0 *i) * i
    'orangered3': c = 205 + ( 55 +	  0 *i) * i
    'orangered4': c = 139 + ( 37 +	  0 *i) * i
    'red1': c = 255 + (  0 +	  0 *i) * i
    'red2': c = 238 + (  0 +	  0 *i) * i
    'red3': c = 205 + (  0 +	  0 *i) * i
    'red4': c = 139 + (  0 +	  0 *i) * i
    'deeppink1': c = 255 + ( 20 + 147 *i) * i
    'deeppink2': c = 238 + ( 18 + 137 *i) * i
    'deeppink3': c = 205 + ( 16 + 118 *i) * i
    'deeppink4': c = 139 + ( 10 +	 80 *i) * i
    'hotpink1': c = 255 + (110 + 180 *i) * i
    'hotpink2': c = 238 + (106 + 167 *i) * i
    'hotpink3': c = 205 + ( 96 + 144 *i) * i
    'hotpink4': c = 139 + ( 58 +  98 *i) * i
    'pink1': c = 255 + (181 + 197 *i) * i
    'pink2': c = 238 + (169 + 184 *i) * i
    'pink3': c = 205 + (145 + 158 *i) * i
    'pink4': c = 139 + ( 99 + 108 *i) * i
    'lightpink1': c = 255 + (174 + 185 *i) * i
    'lightpink2': c = 238 + (162 + 173 *i) * i
    'lightpink3': c = 205 + (140 + 149 *i) * i
    'lightpink4': c = 139 + ( 95 + 101 *i) * i
    'palevioletred1': c = 255 + (130 + 171 *i) * i
    'palevioletred2': c = 238 + (121 + 159 *i) * i
    'palevioletred3': c = 205 + (104 + 137 *i) * i
    'palevioletred4': c = 139 + ( 71 +	 93 *i) * i
    'maroon1': c = 255 + ( 52 + 179 *i) * i
    'maroon2': c = 238 + ( 48 + 167 *i) * i
    'maroon3': c = 205 + ( 41 + 144 *i) * i
    'maroon4': c = 139 + ( 28 +	 98 *i) * i
    'violetred1': c = 255 + ( 62 + 150 *i) * i
    'violetred2': c = 238 + ( 58 + 140 *i) * i
    'violetred3': c = 205 + ( 50 + 120 *i) * i
    'violetred4': c = 139 + ( 34 +	 82 *i) * i
    'magenta1': c = 255 + (  0 + 255 *i) * i
    'magenta2': c = 238 + (  0 + 238 *i) * i
    'magenta3': c = 205 + (  0 + 205 *i) * i
    'magenta4': c = 139 + (  0 + 139 *i) * i
    'orchid1': c = 255 + (131 + 250 *i) * i
    'orchid2': c = 238 + (122 + 233 *i) * i
    'orchid3': c = 205 + (105 + 201 *i) * i
    'orchid4': c = 139 + ( 71 + 137 *i) * i
    'plum1': c = 255 + (187 + 255 *i) * i
    'plum2': c = 238 + (174 + 238 *i) * i
    'plum3': c = 205 + (150 + 205 *i) * i
    'plum4': c = 139 + (102 + 139 *i) * i
    'mediumorchid1': c = 224 + (102 + 255 *i) * i
    'mediumorchid2': c = 209 + ( 95 + 238 *i) * i
    'mediumorchid3': c = 180 + ( 82 + 205 *i) * i
    'mediumorchid4': c = 122 + ( 55 + 139 *i) * i
    'darkorchid1': c = 191 + ( 62 + 255 *i) * i
    'darkorchid2': c = 178 + ( 58 + 238 *i) * i
    'darkorchid3': c = 154 + ( 50 + 205 *i) * i
    'darkorchid4': c = 104 + ( 34 + 139 *i) * i
    'purple1': c = 155 + ( 48 + 255 *i) * i
    'purple2': c = 145 + ( 44 + 238 *i) * i
    'purple3': c = 125 + ( 38 + 205 *i) * i
    'purple4': c =  85 + ( 26 + 139 *i) * i
    'mediumpurple1': c = 171 + (130 + 255 *i) * i
    'mediumpurple2': c = 159 + (121 + 238 *i) * i
    'mediumpurple3': c = 137 + (104 + 205 *i) * i
    'mediumpurple4': c =  93 + ( 71 + 139 *i) * i
    'thistle1': c = 255 + (225 + 255 *i) * i
    'thistle2': c = 238 + (210 + 238 *i) * i
    'thistle3': c = 205 + (181 + 205 *i) * i
    'thistle4': c = 139 + (123 + 139 *i) * i
    'gray0': c =   0 + (  0 +   0 *i) * i
    'grey0': c =   0 + (  0 +   0 *i) * i
    'gray1': c =   3 + (  3 +   3 *i) * i
    'grey1': c =   3 + (  3 +   3 *i) * i
    'gray2': c =   5 + (  5 +   5 *i) * i
    'grey2': c =   5 + (  5 +   5 *i) * i
    'gray3': c =   8 + (  8 +   8 *i) * i
    'grey3': c =   8 + (  8 +   8 *i) * i
    'gray4': c =  10 + ( 10 +  10 *i) * i
    'grey4': c =  10 + ( 10 +  10 *i) * i
    'gray5': c =  13 + ( 13 +  13 *i) * i
    'grey5': c =  13 + ( 13 +  13 *i) * i
    'gray6': c =  15 + ( 15 +  15 *i) * i
    'grey6': c =  15 + ( 15 +  15 *i) * i
    'gray7': c =  18 + ( 18 +  18 *i) * i
    'grey7': c =  18 + ( 18 +  18 *i) * i
    'gray8': c =  20 + ( 20 +  20 *i) * i
    'grey8': c =  20 + ( 20 +  20 *i) * i
    'gray9': c =  23 + ( 23 +  23 *i) * i
    'grey9': c =  23 + ( 23 +  23 *i) * i
    'gray10': c =  26 + ( 26 +  26 *i) * i
    'grey10': c =  26 + ( 26 +  26 *i) * i
    'gray11': c =  28 + ( 28 +  28 *i) * i
    'grey11': c =  28 + ( 28 +  28 *i) * i
    'gray12': c =  31 + ( 31 +  31 *i) * i
    'grey12': c =  31 + ( 31 +  31 *i) * i
    'gray13': c =  33 + ( 33 +  33 *i) * i
    'grey13': c =  33 + ( 33 +  33 *i) * i
    'gray14': c =  36 + ( 36 +  36 *i) * i
    'grey14': c =  36 + ( 36 +  36 *i) * i
    'gray15': c =  38 + ( 38 +  38 *i) * i
    'grey15': c =  38 + ( 38 +  38 *i) * i
    'gray16': c =  41 + ( 41 +  41 *i) * i
    'grey16': c =  41 + ( 41 +  41 *i) * i
    'gray17': c =  43 + ( 43 +  43 *i) * i
    'grey17': c =  43 + ( 43 +  43 *i) * i
    'gray18': c =  46 + ( 46 +  46 *i) * i
    'grey18': c =  46 + ( 46 +  46 *i) * i
    'gray19': c =  48 + ( 48 +  48 *i) * i
    'grey19': c =  48 + ( 48 +  48 *i) * i
    'gray20': c =  51 + ( 51 +  51 *i) * i
    'grey20': c =  51 + ( 51 +  51 *i) * i
    'gray21': c =  54 + ( 54 +  54 *i) * i
    'grey21': c =  54 + ( 54 +  54 *i) * i
    'gray22': c =  56 + ( 56 +  56 *i) * i
    'grey22': c =  56 + ( 56 +  56 *i) * i
    'gray23': c =  59 + ( 59 +  59 *i) * i
    'grey23': c =  59 + ( 59 +  59 *i) * i
    'gray24': c =  61 + ( 61 +  61 *i) * i
    'grey24': c =  61 + ( 61 +  61 *i) * i
    'gray25': c =  64 + ( 64 +  64 *i) * i
    'grey25': c =  64 + ( 64 +  64 *i) * i
    'gray26': c =  66 + ( 66 +  66 *i) * i
    'grey26': c =  66 + ( 66 +  66 *i) * i
    'gray27': c =  69 + ( 69 +  69 *i) * i
    'grey27': c =  69 + ( 69 +  69 *i) * i
    'gray28': c =  71 + ( 71 +  71 *i) * i
    'grey28': c =  71 + ( 71 +  71 *i) * i
    'gray29': c =  74 + ( 74 +  74 *i) * i
    'grey29': c =  74 + ( 74 +  74 *i) * i
    'gray30': c =  77 + ( 77 +  77 *i) * i
    'grey30': c =  77 + ( 77 +  77 *i) * i
    'gray31': c =  79 + ( 79 +  79 *i) * i
    'grey31': c =  79 + ( 79 +  79 *i) * i
    'gray32': c =  82 + ( 82 +  82 *i) * i
    'grey32': c =  82 + ( 82 +  82 *i) * i
    'gray33': c =  84 + ( 84 +  84 *i) * i
    'grey33': c =  84 + ( 84 +  84 *i) * i
    'gray34': c =  87 + ( 87 +  87 *i) * i
    'grey34': c =  87 + ( 87 +  87 *i) * i
    'gray35': c =  89 + ( 89 +  89 *i) * i
    'grey35': c =  89 + ( 89 +  89 *i) * i
    'gray36': c =  92 + ( 92 +  92 *i) * i
    'grey36': c =  92 + ( 92 +  92 *i) * i
    'gray37': c =  94 + ( 94 +  94 *i) * i
    'grey37': c =  94 + ( 94 +  94 *i) * i
    'gray38': c =  97 + ( 97 +  97 *i) * i
    'grey38': c =  97 + ( 97 +  97 *i) * i
    'gray39': c =  99 + ( 99 +  99 *i) * i
    'grey39': c =  99 + ( 99 +  99 *i) * i
    'gray40': c = 102 + (102 + 102 *i) * i
    'grey40': c = 102 + (102 + 102 *i) * i
    'gray41': c = 105 + (105 + 105 *i) * i
    'grey41': c = 105 + (105 + 105 *i) * i
    'gray42': c = 107 + (107 + 107 *i) * i
    'grey42': c = 107 + (107 + 107 *i) * i
    'gray43': c = 110 + (110 + 110 *i) * i
    'grey43': c = 110 + (110 + 110 *i) * i
    'gray44': c = 112 + (112 + 112 *i) * i
    'grey44': c = 112 + (112 + 112 *i) * i
    'gray45': c = 115 + (115 + 115 *i) * i
    'grey45': c = 115 + (115 + 115 *i) * i
    'gray46': c = 117 + (117 + 117 *i) * i
    'grey46': c = 117 + (117 + 117 *i) * i
    'gray47': c = 120 + (120 + 120 *i) * i
    'grey47': c = 120 + (120 + 120 *i) * i
    'gray48': c = 122 + (122 + 122 *i) * i
    'grey48': c = 122 + (122 + 122 *i) * i
    'gray49': c = 125 + (125 + 125 *i) * i
    'grey49': c = 125 + (125 + 125 *i) * i
    'gray50': c = 127 + (127 + 127 *i) * i
    'grey50': c = 127 + (127 + 127 *i) * i
    'gray51': c = 130 + (130 + 130 *i) * i
    'grey51': c = 130 + (130 + 130 *i) * i
    'gray52': c = 133 + (133 + 133 *i) * i
    'grey52': c = 133 + (133 + 133 *i) * i
    'gray53': c = 135 + (135 + 135 *i) * i
    'grey53': c = 135 + (135 + 135 *i) * i
    'gray54': c = 138 + (138 + 138 *i) * i
    'grey54': c = 138 + (138 + 138 *i) * i
    'gray55': c = 140 + (140 + 140 *i) * i
    'grey55': c = 140 + (140 + 140 *i) * i
    'gray56': c = 143 + (143 + 143 *i) * i
    'grey56': c = 143 + (143 + 143 *i) * i
    'gray57': c = 145 + (145 + 145 *i) * i
    'grey57': c = 145 + (145 + 145 *i) * i
    'gray58': c = 148 + (148 + 148 *i) * i
    'grey58': c = 148 + (148 + 148 *i) * i
    'gray59': c = 150 + (150 + 150 *i) * i
    'grey59': c = 150 + (150 + 150 *i) * i
    'gray60': c = 153 + (153 + 153 *i) * i
    'grey60': c = 153 + (153 + 153 *i) * i
    'gray61': c = 156 + (156 + 156 *i) * i
    'grey61': c = 156 + (156 + 156 *i) * i
    'gray62': c = 158 + (158 + 158 *i) * i
    'grey62': c = 158 + (158 + 158 *i) * i
    'gray63': c = 161 + (161 + 161 *i) * i
    'grey63': c = 161 + (161 + 161 *i) * i
    'gray64': c = 163 + (163 + 163 *i) * i
    'grey64': c = 163 + (163 + 163 *i) * i
    'gray65': c = 166 + (166 + 166 *i) * i
    'grey65': c = 166 + (166 + 166 *i) * i
    'gray66': c = 168 + (168 + 168 *i) * i
    'grey66': c = 168 + (168 + 168 *i) * i
    'gray67': c = 171 + (171 + 171 *i) * i
    'grey67': c = 171 + (171 + 171 *i) * i
    'gray68': c = 173 + (173 + 173 *i) * i
    'grey68': c = 173 + (173 + 173 *i) * i
    'gray69': c = 176 + (176 + 176 *i) * i
    'grey69': c = 176 + (176 + 176 *i) * i
    'gray70': c = 179 + (179 + 179 *i) * i
    'grey70': c = 179 + (179 + 179 *i) * i
    'gray71': c = 181 + (181 + 181 *i) * i
    'grey71': c = 181 + (181 + 181 *i) * i
    'gray72': c = 184 + (184 + 184 *i) * i
    'grey72': c = 184 + (184 + 184 *i) * i
    'gray73': c = 186 + (186 + 186 *i) * i
    'grey73': c = 186 + (186 + 186 *i) * i
    'gray74': c = 189 + (189 + 189 *i) * i
    'grey74': c = 189 + (189 + 189 *i) * i
    'gray75': c = 191 + (191 + 191 *i) * i
    'grey75': c = 191 + (191 + 191 *i) * i
    'gray76': c = 194 + (194 + 194 *i) * i
    'grey76': c = 194 + (194 + 194 *i) * i
    'gray77': c = 196 + (196 + 196 *i) * i
    'grey77': c = 196 + (196 + 196 *i) * i
    'gray78': c = 199 + (199 + 199 *i) * i
    'grey78': c = 199 + (199 + 199 *i) * i
    'gray79': c = 201 + (201 + 201 *i) * i
    'grey79': c = 201 + (201 + 201 *i) * i
    'gray80': c = 204 + (204 + 204 *i) * i
    'grey80': c = 204 + (204 + 204 *i) * i
    'gray81': c = 207 + (207 + 207 *i) * i
    'grey81': c = 207 + (207 + 207 *i) * i
    'gray82': c = 209 + (209 + 209 *i) * i
    'grey82': c = 209 + (209 + 209 *i) * i
    'gray83': c = 212 + (212 + 212 *i) * i
    'grey83': c = 212 + (212 + 212 *i) * i
    'gray84': c = 214 + (214 + 214 *i) * i
    'grey84': c = 214 + (214 + 214 *i) * i
    'gray85': c = 217 + (217 + 217 *i) * i
    'grey85': c = 217 + (217 + 217 *i) * i
    'gray86': c = 219 + (219 + 219 *i) * i
    'grey86': c = 219 + (219 + 219 *i) * i
    'gray87': c = 222 + (222 + 222 *i) * i
    'grey87': c = 222 + (222 + 222 *i) * i
    'gray88': c = 224 + (224 + 224 *i) * i
    'grey88': c = 224 + (224 + 224 *i) * i
    'gray89': c = 227 + (227 + 227 *i) * i
    'grey89': c = 227 + (227 + 227 *i) * i
    'gray90': c = 229 + (229 + 229 *i) * i
    'grey90': c = 229 + (229 + 229 *i) * i
    'gray91': c = 232 + (232 + 232 *i) * i
    'grey91': c = 232 + (232 + 232 *i) * i
    'gray92': c = 235 + (235 + 235 *i) * i
    'grey92': c = 235 + (235 + 235 *i) * i
    'gray93': c = 237 + (237 + 237 *i) * i
    'grey93': c = 237 + (237 + 237 *i) * i
    'gray94': c = 240 + (240 + 240 *i) * i
    'grey94': c = 240 + (240 + 240 *i) * i
    'gray95': c = 242 + (242 + 242 *i) * i
    'grey95': c = 242 + (242 + 242 *i) * i
    'gray96': c = 245 + (245 + 245 *i) * i
    'grey96': c = 245 + (245 + 245 *i) * i
    'gray97': c = 247 + (247 + 247 *i) * i
    'grey97': c = 247 + (247 + 247 *i) * i
    'gray98': c = 250 + (250 + 250 *i) * i
    'grey98': c = 250 + (250 + 250 *i) * i
    'gray99': c = 252 + (252 + 252 *i) * i
    'grey99': c = 252 + (252 + 252 *i) * i
    'gray100': c = 255 + (255 + 255 *i) * i
    'grey100': c = 255 + (255 + 255 *i) * i
    'darkgrey':    c = 169 + (169 + 169 *i) * i
    'darkgray':    c = 169 + (169 + 169 *i) * i
    'darkblue':    c = 0   + (  0 + 139 *i) * i
    'darkcyan':    c = 0   + (139 + 139 *i) * i
    'darkmagenta': c = 139 + (  0 + 139 *i) * i
    'darkred':     c = 139 + (  0 +   0 *i) * i
    'lightgreen':  c = 144 + (238 + 144 *i) * i
    else:          c = 0
endcase

return, c
end
